import { LitElement, html } from "lit";
import { customElement, property, state } from "lit/decorators.js";
import { when } from "lit/directives/when.js";
import { renderLinkWithItemAnalytics } from "../item-link/item-link.js";
import { bindings } from "../../../decorators/bindings.js";
import { errorGuard } from "../../../decorators/error-guard.js";
import { LightDomMixin } from "../../../mixins/light-dom.js";
import { buildCustomEvent } from "../../../utils/event-utils.js";
import "../../search/atomic-result-text/atomic-result-text.js";
import { bindingGuard } from "../../../decorators/binding-guard.js";
function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : null === desc ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(k, v);
}
class AtomicSmartSnippetSource extends LightDomMixin(LitElement) {
    initialize() {
        this.addEventListener('atomic/resolveResult', this.handleResolveResult);
    }
    disconnectedCallback() {
        super.disconnectedCallback();
        this.removeEventListener('atomic/resolveResult', this.handleResolveResult);
    }
    dispatchSourceEvent(eventName) {
        this.dispatchEvent(buildCustomEvent(eventName));
    }
    handleSourceEvent(eventName) {
        this.dispatchSourceEvent(eventName);
        switch(eventName){
            case 'select-source':
                this.onSelectSource?.();
                break;
            case 'begin-delayed-select-source':
                this.onBeginDelayedSelectSource?.();
                break;
            case 'cancel-pending-select-source':
                this.onCancelPendingSelectSource?.();
                break;
        }
    }
    render() {
        return html`${when(this.source, ()=>html`
        ${renderLinkWithItemAnalytics({
                props: {
                    title: this.source.clickUri,
                    href: this.source.clickUri,
                    className: 'block truncate',
                    part: 'source-url',
                    attributes: this.anchorAttributes,
                    onSelect: ()=>this.handleSourceEvent('select-source'),
                    onBeginDelayedSelect: ()=>this.handleSourceEvent('begin-delayed-select-source'),
                    onCancelPendingSelect: ()=>this.handleSourceEvent('cancel-pending-select-source')
                }
            })(html`${this.source.clickUri}`)}
        ${renderLinkWithItemAnalytics({
                props: {
                    title: this.source.title,
                    href: this.source.clickUri,
                    attributes: this.anchorAttributes,
                    className: 'block',
                    part: 'source-title',
                    onSelect: ()=>this.handleSourceEvent('select-source'),
                    onBeginDelayedSelect: ()=>this.handleSourceEvent('begin-delayed-select-source'),
                    onCancelPendingSelect: ()=>this.handleSourceEvent('cancel-pending-select-source')
                }
            })(html`<atomic-result-text
            field="title"
            default="no-title"
          ></atomic-result-text>`)}
      `)}`;
    }
    constructor(...args){
        super(...args), this.handleResolveResult = (event)=>{
            event.preventDefault();
            event.stopPropagation();
            if (this.source) event.detail(this.source);
        };
    }
}
_ts_decorate([
    property({
        reflect: true,
        type: Object
    }),
    _ts_metadata("design:type", "u" < typeof Result ? Object : Result)
], AtomicSmartSnippetSource.prototype, "source", void 0);
_ts_decorate([
    property({
        type: Array
    }),
    _ts_metadata("design:type", Array)
], AtomicSmartSnippetSource.prototype, "anchorAttributes", void 0);
_ts_decorate([
    property({
        attribute: 'onSelectSource'
    }),
    _ts_metadata("design:type", Function)
], AtomicSmartSnippetSource.prototype, "onSelectSource", void 0);
_ts_decorate([
    property({
        attribute: 'onBeginDelayedSelectSource'
    }),
    _ts_metadata("design:type", Function)
], AtomicSmartSnippetSource.prototype, "onBeginDelayedSelectSource", void 0);
_ts_decorate([
    property({
        attribute: 'onCancelPendingSelectSource'
    }),
    _ts_metadata("design:type", Function)
], AtomicSmartSnippetSource.prototype, "onCancelPendingSelectSource", void 0);
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof AnyBindings ? Object : AnyBindings)
], AtomicSmartSnippetSource.prototype, "bindings", void 0);
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof Error ? Object : Error)
], AtomicSmartSnippetSource.prototype, "error", void 0);
_ts_decorate([
    errorGuard(),
    bindingGuard(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", []),
    _ts_metadata("design:returntype", void 0)
], AtomicSmartSnippetSource.prototype, "render", null);
AtomicSmartSnippetSource = _ts_decorate([
    customElement('atomic-smart-snippet-source'),
    bindings()
], AtomicSmartSnippetSource);
export { AtomicSmartSnippetSource };
